program ArareAnal

  !⥸塼ɤ߹
  use gt4_history
  use fileset
  use gridset 
  use debugset
  use timeset
  use dc_trace
  use dc_string

  use MoistAdjust
  use WarmRainPrm 
  use MoistBuoyancy
  use MoistFunc

  use Average
  use MoistBuoyancy
  use DynFunc
  use basicset
  
  use chemcalc
  use Boundary

  implicit none
  
  !ѿ
  real(8), allocatable :: xz_PotTemp(:,:)
  real(8), allocatable :: xz_Exner(:,:)
  real(8), allocatable :: pz_VelX(:,:)
  real(8), allocatable :: xr_VelZ(:,:)
  real(8), allocatable :: xza_MixRt(:,:,:)
  real(8), allocatable :: xz_Temp(:,:)
  real(8), allocatable :: xz_VPotTemp(:,:)
  real(8), allocatable :: xza_Rho(:,:,:)
  real(8), allocatable :: xza_CloudPhys1(:,:,:)
  real(8), allocatable :: xza_CloudPhys2(:,:,:)
  real(8), allocatable :: xza_CloudPhys3(:,:,:)
  real(8), allocatable :: xz_BuoyAll(:,:)
  real(8), allocatable :: xz_BuoyTemp(:,:)
  real(8), allocatable :: xz_BuoyMolWt(:,:)
  real(8), allocatable :: xz_BuoyLoad(:,:)
  real(8)              :: AnalTime

  real(8), allocatable :: xz_TempAll(:,:)
  real(8), allocatable :: xz_PressAll(:,:)
  real(8), allocatable :: xz_DelNH4SH(:,:)
  real(8), allocatable :: xz_EquivConst(:,:)
  real(8), allocatable :: xza_DelMixRt(:,:,:)

  real(8), allocatable :: xz_Cloud(:,:)
  real(8), allocatable :: xz_Rain(:,:)

  integer      :: LoopNum, LoopNum2
  integer      :: GasNum(10)
  integer      :: CloudNum(10)
  integer      :: RainNum(10)
  integer      :: NH3Num  
  integer      :: H2SNum  
  integer      :: NH4SHNum

  integer             :: spc, t, s
  character(50)       :: cfgfile
  character(50)       :: AnalFile

!  call setdebug
    
  !----------------------------------------------------------------------
  ! ѿȷ⥸塼ν
  !----------------------------------------------------------------------
  !NAMELIST եμ
  call getarg( 1, cfgfile )

  write(*,*) cfgfile
  
  !I/O ե̾ν
  !  NAMELIST ե̾ꤷ, deepconv/arare 
  !  ϥե̾ NAMELIST 
  call fileset_init(cfgfile)
  
  !ǥХν
  !  NAMELIST , ǥХåϥåؤԤ.  
  call debugset_init(cfgfile)
  
  !˴ؤν
  !  NAMELIST ɬפʾɤ߼, ִϢѿԤ. 
  call timeset_init(cfgfile)

  !ʻν
  !  NAMELIST , ʻ׻
  call gridset_init(cfgfile)

  !ܾξν
  !  NAMELIST , ܾꤹ.
  call basicset_init(cfgfile)
  
  !ܾ, μ.
  allocate( &
    &       xz_PotTemp(DimXMin:DimXMax, DimZMin:DimZMax ),           &
    &       xz_Exner(DimXMin:DimXMax, DimZMin:DimZMax ),             &
    &       pz_VelX(DimXMin:DimXMax, DimZMin:DimZMax ),              &
    &       xr_VelZ(DimXMin:DimXMax, DimZMin:DimZMax ),              &
    &       xza_MixRt(DimXMin:DimXMax, DimZMin:DimZMax, SpcNum ),    &
    &       xz_Temp(DimXMin:DimXMax, DimZMin:DimZMax ),              &
    &       xz_VPotTemp(DimXMin:DimXMax, DimZMin:DimZMax ),          &
    &       xza_Rho(DimXMin:DimXMax, DimZMin:DimZMax,SpcNum ),       &
    &       xza_CloudPhys1(DimXMin:DimXMax, DimZMin:DimZMax,SpcNum ),&
    &       xza_CloudPhys2(DimXMin:DimXMax, DimZMin:DimZMax,SpcNum ),&
    &       xza_CloudPhys3(DimXMin:DimXMax, DimZMin:DimZMax,SpcNum ),&
!
    &       xz_TempAll(DimXMin:DimXMax, DimZMin:DimZMax ),              &
    &       xz_PressAll(DimXMin:DimXMax, DimZMin:DimZMax ),              &
    &       xz_DelNH4SH(DimXMin:DimXMax, DimZMin:DimZMax ),              &
    &       xz_EquivConst(DimXMin:DimXMax, DimZMin:DimZMax ),              &
    &       xza_DelMixRt(DimXMin:DimXMax, DimZMin:DimZMax, SpcNum ),    &
!
    &       xz_Cloud(DimXMin:DimXMax, DimZMin:DimZMax ),              &
    &       xz_Rain(DimXMin:DimXMax, DimZMin:DimZMax ),    &
!
    &       xz_BuoyAll(DimXMin:DimXMax, DimZMin:DimZMax ),           &
    &       xz_BuoyTemp(DimXMin:DimXMax, DimZMin:DimZMax ),          &
    &       xz_BuoyMolWt(DimXMin:DimXMax, DimZMin:DimZMax ),         &
    &       xz_BuoyLoad(DimXMin:DimXMax, DimZMin:DimZMax )          )

  LoopNum  = 0 
  LoopNum2 = 0
  RainNum = 0
  CloudNum = 0
  GasNum   = 0
  NH3Num   = 0
  H2SNum   = 0
  NH4SHNum = 0

  AnalFile = HistoryFile(1:len_trim(HistoryFile)-3) // '_anal.nc'
  call AnalFile_Open( )
  call AnalFile_BasicZ_Get( )
  call MoistBuoy_Init()             !ʬ̤ФϷ׻롼ν  
  call WarmRainPrm_Init()           !ȤΥѥ᥿ꥼν
  call MoistAdjust_Init()           !Ĵˡν
  call WarmRainPrm_prm( LoopNum, LoopNum2, RainNum, CloudNum, GasNum, NH3Num, H2SNum, NH4SHNum )
    
  write(*,*) TimeInt,  TimeDisp , TimeInt/  TimeDisp 


  do t = 1, int( TimeInt / TimeDisp ) + 1

    call AnalFile_Get(                                           &
      &       t,  AnalTime,                                      &
      &       xz_PotTemp, xz_Exner, pz_VelX, xr_VelZ, xza_MixRt )
    write(*,*) t, AnalTime
    

    !----------------------------------------------------------------
    ! 
    !----------------------------------------------------------------
    xz_Cloud = 0.0d0
    xz_Rain  = 0.0d0


    !----------------------------------------------------------------
    ! ̩, , ̤η׻
    !----------------------------------------------------------------
    do spc = 1, SpcNum
      xza_Rho(:,:, spc) =                                                   &
        &  xz_DensBasicZ * ( xza_MixRtBasicZ(:,:,spc) + xza_MixRt(:,:,spc) )
    end do

    xz_TempAll = &
      &   ( xz_Exner + xz_ExnerBasicZ ) * ( xz_PotTemp + xz_PotTempBasicZ ) 
    xz_Temp = xz_TempAll - xz_ExnerBasicZ * xz_PotTempBasicZ 
    
    xz_VPotTemp = xz_PotTemp / xz_EffMolWtBasicZ


    !----------------------------------------------------------------
    ! Ϥη׻
    !----------------------------------------------------------------
    xz_PressAll = PressBasis * ((xz_Exner + xz_ExnerBasicZ ) ** (CpDry / GasRDry))
    
    
    !----------------------------------------------------------------
    ! 
    !----------------------------------------------------------------
    xz_BuoyTemp  =  xz_avr_xr( xr_Buoy( xz_PotTemp ) )
    xz_BuoyMolWt =  xz_avr_xr( xr_BuoyMolWt( xza_MixRt ) )
    xz_BuoyLoad  =  xz_avr_xr( xr_BuoyLoad( xza_MixRt ) )
    xz_BuoyAll   =  xz_BuoyTemp + xz_BuoyMolWt + xz_BuoyLoad
    
    
    !----------------------------------------------------------------
    ! ʪ̤׻
    !----------------------------------------------------------------
    xza_CloudPhys1 = xza_Cloud2Rain( xza_MixRt, 2.0d0 * DelTimeLong )

    if ( LoopNum /= 0 ) then 
      xza_CloudPhys2 =                                         &
        &   xza_Rain2Gas(xz_Exner, xz_PotTemp, xza_MixRt, 2.0d0 * DelTimeLong )    
    end if
    if ( NH4SHNum /= 0 ) then     
      xza_CloudPhys2 =                                         &
        &   xza_CloudPhys2                                      &
        & + xza_CloudPhys2 + xza_Rain2GasNH4SH(xz_Exner, xz_PotTemp, xza_MixRt, 2.0d0 * DelTimeLong )
    end if

    do spc = 1, SpcNum      
      xza_CloudPhys3(:,:,spc) = xz_FallRain(xza_MixRt(:,:,spc), spc)
    end do
    

    !----------------------------------------------------------------
    ! , ޤȤ
    !----------------------------------------------------------------
    do s = 1, LoopNum2
      xz_Cloud = xz_Cloud + xza_MixRt(:,:,CloudNum(s))
      xz_Rain  = xz_Rain  + xza_MixRt(:,:,RainNum(s))
    end do


    !----------------------------------------------------------------
    ! ˰¾Υå
    !----------------------------------------------------------------
    if (LoopNum /= 0 ) then 
      do s = 1, LoopNum
        xza_DelMixRt(:,:,GasNum(s)) =                       &
          & xz_SvapPress(SpcWetID(CloudNum(s)), xz_TempAll) &
         &  * MolWtWet(CloudNum(s))                        &
          &  / (MolWtDry * xz_PressAll)                     &
          & - xza_MixRt(:,:,GasNum(s))
      end do
    end if

    !----------------------------------------------------------------
    ! NH4SH ʿ, ̤˰٤Υå
    !----------------------------------------------------------------
    if ( NH4SHNum /= 0 ) then 

      xz_DelNH4SH =                                              &
        & dlog(                                                  &
        &   ( xza_MixRt(:,:,NH3Num) + xza_MixRtBasicZ(:,:,NH3Num) ) &
        &     * xz_PressAll * MolWtDry / MolWtWet(NH3Num ) &
        & * ( xza_MixRt(:,:,H2SNum) + xza_MixRtBasicZ(:,:,H2SNum) ) &
        &     * xz_PressAll * MolWtDry / MolWtWet(H2SNum)           &
        &  )
      
      xz_EquivConst =                                              &
        & 61.781d0 - 10834.0d0 / xz_TempAll - dlog(1.0d2) 
 
      xza_DelMixRt(:,:,NH4SHNum) =                             &
        & - xz_DelMixRtNH4SH(                                  &
        &     xz_TempAll, xz_PressAll,                         &
        &     xza_MixRt(:,:,NH3Num), xza_MixRt(:,:,H2SNum),    &
        &     MolWtWet(NH3Num), MolWtWet(H2SNum)               &
        &    )
    end if

    !----------------------------------------------------------------    
    ! ե
    !----------------------------------------------------------------
    call AnalFile_OutPut( AnalTime )

  end do
  
  !----------------------------------------------------------------    
  ! եĤ
  !----------------------------------------------------------------    
  call HistoryClose

    
contains

  subroutine AnalFile_Open( )
    !
    !ϥե
    !
    
    !ۤηػ
    implicit none
    
    !ѿ
    real(4)        :: SpcID(SpcNum)
!    character(50)  :: AnalFile
    integer        :: s
    
    do s = 1, SpcNum
      SpcID(s) = s * 1.0d0
    end do


    !-----------------------------------------------------------
    ! ҥȥ꡼
    !-----------------------------------------------------------
    call HistoryCreate(                              &
      & file = AnalFile,                             &
      & title = exptitle,                            &
      & source = expsrc,                             &
      & institution = expinst,                       &
      & dims=(/'x','z','s','t'/),                    &
      & dimsizes=(/FileNX, FileNZ, SpcNum, 0/),      &
      & longnames=(/'X-coordinate',                  &
      &             'Z-coordinate',                  &
      &             'Species Num ',                  &
      &             'Time        '/),                &
      & units=(/'m','m','1','s'/), origin=0.0,       &
      & interval=0.0 )
!      & units=(/'m','m','1','s'/) )
    
    !-----------------------------------------------------------  
    ! ν
    !-----------------------------------------------------------
    call HistoryPut('x', s_X( DimXMin: DimXMax ) )
    call HistoryPut('z', s_Z( DimZMin: DimZMax ) )
    call HistoryPut('s', real(SpcID, 4))


    !-----------------------------------------------------------  
    ! Ѥѿν
    !-----------------------------------------------------------  
    !̤ξ
    call HistoryAddVariable(                                     &
      & varname='VPotTemp', dims=(/'x','z','t'/),                &
      & longname='disturbunce of virtual potential temperature', &
      & units='K', xtype='double' )

    !پ
    call HistoryAddVariable(                         &
      & varname='Temp', dims=(/'x','z','t'/),        &
      & longname='disturbunce of temperature',       &
      & units='K', xtype='double' )

    !̩
    call HistoryAddVariable(                          &
      & varname='Rho', dims=(/'x','z','s','t'/),      &
      & longname='Density of condensable components', &
      & units='kg m|-2"', xtype='double' )

    !˰¾
    call HistoryAddVariable(                          &
      & varname='MixRtSat', dims=(/'x','z','s','t'/),      &
      & longname='Saturated Mixing ratio of condensable components', &
      & units='kg kg|-1"', xtype='double' )

    call HistoryAddVariable(                                         &
      & varname='Cloud2Rain', dims=(/'x','z','s','t'/),              &
      & longname='WarmRainPrm Cloud2Rain of condensable components', &
      & units='kg kg|-1"', xtype='double' ) 
 
    call HistoryAddVariable(                                       &
      & varname='Rain2Gas', dims=(/'x','z','s','t'/),              &
      & longname='WarmRainPrm Rain2Gas of condensable components', &
      & units='kg kg|-1"', xtype='double' ) 

    call HistoryAddVariable(                                        &
      & varname='FallRain', dims=(/'x','z','s','t'/),               &
      & longname='WarmRainPrm FallRain of condensable components',  &
      & units='kg kg|-1"', xtype='double' ) 

    call HistoryAddVariable(                                        &
      & varname='BuoyAll', dims=(/'x','z','t'/),                       &
      & longname='Buoyancy',                                        &
      & units=' ', xtype='double' ) 

    call HistoryAddVariable(                                        &
      & varname='BuoyTemp', dims=(/'x','z','t'/),                       &
      & longname='Buoyancy',                                        &
      & units=' ', xtype='double' ) 

    call HistoryAddVariable(                                        &
      & varname='BuoyMolWt', dims=(/'x','z','t'/),                       &
      & longname='Buoyancy',                                        &
      & units=' ', xtype='double' ) 

    call HistoryAddVariable(                                        &
      & varname='BuoyLoad', dims=(/'x','z','t'/),                       &
      & longname='Buoyancy',                                        &
      & units=' ', xtype='double' ) 

    !----------------------------------------------------------------
    ! ˰ĴˡϢ
    !----------------------------------------------------------------

    call HistoryAddVariable(                                       &
      & varname='DelMixRt', dims=(/'x','z','s','t'/),              &
      & longname='Difference between DelMixRt and Sarurated vaper pressure',                      &
      & units='kg kg|-1"', xtype='double' ) 

    call HistoryAddVariable(                                       &
      & varname='DelNH4SH', dims=(/'x','z','t'/),                  &
      & longname='Difference between Equiv-Const',                 &
      & units='kg kg|-1"', xtype='double' ) 

    call HistoryAddVariable(                                       &
      & varname='EquivConst', dims=(/'x','z','t'/),                  &
      & longname='Difference between Equiv-Const',                 &
      & units='kg kg|-1"', xtype='double' ) 

    !----------------------------------------------------------------
    ! ȱ
    !----------------------------------------------------------------
    call HistoryAddVariable(                                       &
      & varname='Cloud', dims=(/'x','z','t'/),                  &
      & longname='All Clouds Mixing Ratio',                 &
      & units='kg kg|-1"', xtype='double' ) 

    call HistoryAddVariable(                                       &
      & varname='Rain', dims=(/'x','z','t'/),                  &
      & longname='All Rains Mixing Ratio',                 &
      & units='kg kg|-1"', xtype='double' ) 

  end subroutine AnalFile_Open



  subroutine AnalFile_OutPut( Time )

    real(8), intent(in) :: Time    

    !----------------------------------------------------------------
    ! ͤ
    !----------------------------------------------------------------
    call HistoryPut( 't', Time )

    call HistoryPut( 'Temp', xz_Temp)
    
    call HistoryPut( 'VPotTemp', xz_VPotTemp)
    
    call HistoryPut( 'Rho', xza_Rho)
    
    call HistoryPut( 'Cloud2Rain', xza_CloudPhys1)

    call HistoryPut( 'Rain2Gas', xza_CloudPhys2)
    
    call HistoryPut( 'FallRain', xza_CloudPhys3)

    call HistoryPut( 'BuoyAll', xz_BuoyAll)

    call HistoryPut( 'BuoyTemp', xz_BuoyTemp)    
    
    call HistoryPut( 'BuoyMolWt', xz_BuoyMolWt)
    
    call HistoryPut( 'BuoyLoad', xz_BuoyLoad)

    call HistoryPut( 'DelMixRt',   xza_DelMixRt)

    call HistoryPut( 'DelNH4SH',   xz_DelNH4SH)

    call HistoryPut( 'EquivConst',   xz_EquivConst)

    call HistoryPut( 'Cloud',   xz_Cloud)

    call HistoryPut( 'Rain',    xz_Rain)
    
  end subroutine AnalFile_OutPut


!!!------------------------------------------------------------------------------!!!
  subroutine AnalFile_Get(                                      &
    &       i, AnalTime,                                        &
    &       xz_PotTemp, xz_Exner, pz_VelX, xr_VelZ, xza_MixRt )

    !ۤηػ
    implicit none

    !ѿ
    integer, intent(in)  :: i    
    real(8), intent(out) :: AnalTime
    real(8), intent(out) :: pz_VelX(:,:)
    real(8), intent(out) :: xr_VelZ(:,:)
    real(8), intent(out) :: xz_Exner(:,:)
    real(8), intent(out) :: xz_PotTemp(:,:)
    real(8), intent(out) :: xza_MixRt(:,:,:)
    character(30)        :: name               !ѿ̾
    character(10)       :: step
    

    step = '^' // adjustl(toChar(i))

    !-------------------------------------------------------------
    !Get a Value from netCDF File
    !-------------------------------------------------------------
    name = "t"
    call HistoryGet( HistoryFile, name, AnalTime, step )
    
    
    !-------------------------------------------------------------    
    ! Get a Value from netCDF File 
    !-------------------------------------------------------------
    name = "VelX"
    call HistoryGet( HistoryFile, name, pz_VelX, range=step )    

    name = "VelZ"
    call HistoryGet( HistoryFile, name, xr_VelZ, range=step )
    
    name = "Exner"
    call HistoryGet( HistoryFile, name, xz_Exner, range=step )
    
    name = "PotTemp"
    call HistoryGet( HistoryFile, name, xz_PotTemp, range=step )

    name = "MixRt"
    call HistoryGet( HistoryFile, name, xza_MixRt, range=step )

  end subroutine AnalFile_Get



  subroutine AnalFile_BasicZ_Get( )

    !ۤηػ
    implicit none

    !ѿ
    real(8) :: xz_DensBZ(DimXMin:DimXMax, DimZMin:DimZMax)
    real(8) :: xz_PotTempBZ(DimXMin:DimXMax, DimZMin:DimZMax)
    real(8) :: xz_ExnerBZ(DimXMin:DimXMax, DimZMin:DimZMax)
    real(8) :: xza_MixRtBZ(DimXMin:DimXMax, DimZMin:DimZMax,SpcNum)
    real(8) :: xz_EffMolWtBZ(DimXMin:DimXMax, DimZMin:DimZMax)
    real(8) :: xz_PressBZ(DimXMin:DimXMax, DimZMin:DimZMax)
    real(8) :: xz_TempBZ(DimXMin:DimXMax, DimZMin:DimZMax)
    real(8) :: xz_VelSoundBZ(DimXMin:DimXMax, DimZMin:DimZMax)
    character(30)        :: name               !ѿ̾
    
    !-------------------------------------------------------------
    ! ܾμ
    !-------------------------------------------------------------
    name = "PressBasicZ"
    call HistoryGet( HistoryFile, name, xz_PressBZ )

    name = "ExnerBasicZ"
    call HistoryGet( HistoryFile, name, xz_ExnerBZ )

    name = "PotTempBasicZ"
    call HistoryGet( HistoryFile, name, xz_PotTempBZ )

    name = "TempBasicZ"
    call HistoryGet( HistoryFile, name, xz_TempBZ )

    name = "DensBasicZ"
    call HistoryGet( HistoryFile, name, xz_DensBZ )

    name = "VelSoundBasicZ"
    call HistoryGet( HistoryFile, name, xz_VelSoundBZ )

    name = "MixRtBasicZ"
    call HistoryGet( HistoryFile, name, xza_MixRtBZ )

    name = "EffMolWtBasicZ"
    call HistoryGet( HistoryFile, name, xz_EffMolWtBZ )

    !----------------------------------------------------------
    ! BasicSet ⥸塼ͤ
    !----------------------------------------------------------
    call BasicSetArray_Init(                       &
      & xz_PressBZ,   xz_ExnerBZ,   xz_TempBZ,     &
      & xz_PotTempBZ, xz_DensBZ,    xz_VelSoundBZ, &
      & xza_MixRtBZ,  xz_EffMolWtBZ )

  end subroutine AnalFile_BasicZ_Get


end program ArareAnal
